package com.its.op.service.its.scrs;

import com.its.op.dao.repository.its.scrs.TbScIxrPhasRepository;
import com.its.op.dto.its.scrs.TbScIxrPhasDto;
import com.its.op.entity.its.scrs.TbScIxrPhas;
import com.its.op.entity.its.scrs.TbScIxrPhasKey;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbScIxrPhasService {

    private final TbScIxrPhasRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbScIxrPhas requireOne(TbScIxrPhasKey sgnlIxrNmbr) throws NoSuchElementException {
        Optional<TbScIxrPhas> info = this.repo.findById(sgnlIxrNmbr);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + sgnlIxrNmbr);
        }
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbScIxrPhasDto> findAll() {
        List<TbScIxrPhasDto> result = new ArrayList<>();
        List<TbScIxrPhas> data = this.repo.findAll();
        for (TbScIxrPhas entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbScIxrPhasDto> findAllList() {
        List<TbScIxrPhasDto> result = new ArrayList<>();
        List<TbScIxrPhas> data = this.repo.findAllList();
        for (TbScIxrPhas entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbScIxrPhasDto findById(TbScIxrPhasKey sgnlIxrNmbr) {
        TbScIxrPhas entity = requireOne(sgnlIxrNmbr);
        return entity.toDto();
    }

    // 데이터 변경
    @Transactional
    public TbScIxrPhasDto updateById(TbScIxrPhasKey sgnlIxrNmbr, TbScIxrPhasDto.TbScIxrPhasUpdReq req) {
        TbScIxrPhas entity = requireOne(sgnlIxrNmbr);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbScIxrPhasDto> mergeInfoList(List<TbScIxrPhasDto.TbScIxrPhasUpdReq> reqList) {
        List<TbScIxrPhasDto> result = new ArrayList<>();
        for (TbScIxrPhasDto.TbScIxrPhasUpdReq req : reqList) {
            TbScIxrPhas obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbScIxrPhasDto mergeInfo(TbScIxrPhasDto.TbScIxrPhasUpdReq req) {
        TbScIxrPhas obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbScIxrPhasDto deleteById(TbScIxrPhasKey sgnlIxrNmbr) {
        TbScIxrPhas entity = requireOne(sgnlIxrNmbr);
        this.repo.deleteById(sgnlIxrNmbr);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbScIxrPhasDto> deleteByIds(List<TbScIxrPhasKey> ids) {
        List<TbScIxrPhasDto> result = new ArrayList<>();
        for (TbScIxrPhasKey id : ids) {
            Optional<TbScIxrPhas> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

    @Transactional(readOnly = true)
    public List<TbScIxrPhasDto> findListById(Integer sgnlIxrNmbr) {
        List<TbScIxrPhas> data = this.repo.findListById(sgnlIxrNmbr);
        List<TbScIxrPhasDto> result = new ArrayList<>();
        for (TbScIxrPhas entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }
}
